import pygame as pg
import numpy as np

def main():
    pg.init()
    screen = pg.display.set_mode((800,600))
    hres=120
    vertical=200
    halfvres=int(vertical/2)
    mod = hres/60
    posx,posy,rot=0,0,0
    running=True
    frame = np.random.uniform(0,1,(hres,vertical,3))

    sky=pg.image.load('c:/python24/skybox.jpg')
    sky = pg.surfarray.array3d(pg.transform.scale(sky, (360, halfvres*2)))

    while running:
        for event in pg.event.get():
            if event.type== pg.QUIT:
                running=False
        
        #similar raycasting
        for i in range(hres):
            rot_i = rot + np.deg2rad(i/mod - 30 )
            sin,cos = np.sin(rot_i), np.cos(rot_i)
            frame[i][:]=sky[int(np.rad2deg(rot_i)%360)][:]/255

            for j in range(halfvres):
                n=halfvres / (halfvres - j)
                x,y=posx + cos*n, posy + sin*n

                if int(x)%2 == int(y) %2:
                    frame[i][halfvres*2 - j -1] = [0,0,0]
                else:
                    frame[i][halfvres*2 -j - 1] = [1,1,1]

        surf = pg.surfarray.make_surface(frame * 255)
        surf = pg.transform.scale(surf, (800,600))

        screen.blit(surf, (0,0))
        pg.display.update()
        posx,posy,rot=movement(posx,posy,rot,pg.key.get_pressed())

def movement(posx,posy,rot,keys):
    if keys[pg.K_LEFT] or keys [ord('a')]:
        rot=rot - 0.1
    if keys[pg.K_RIGHT] or keys [ord('d')]:
        rot=rot + 0.1
    if keys[pg.K_UP] or keys [ord('w')]:
        posx,posy=posx+np.cos(rot)*0.1, posy+np.sin(rot) *0.1
    if keys[pg.K_DOWN] or keys[ord('s')]:
        posx,posy=posx - np.cos(rot)*0.1, posy-np.sin(rot) *0.1
    return posx,posy,rot

if __name__ =='__main__':
    main()
    pg.quit()


