import pygame
import math
import sys
SCREEN_HEIGHT=480
SCREEN_WIDTH=2 * SCREEN_HEIGHT
pygame.init()

MAP_SIZE = 8 

MAP = (
      '########'
      '#  #   #'
      '# #    #'
      '#     ##'
      '#  #   #'
      '#      #'
      '#  #   #'
      '########'
)
#print(MAP,type(MAP))
#sys.exit()

FOV = 60 * math.pi / 180  #60 degrees
HALF_FOV = FOV / 2
player_angle = 180 * math.pi / 180 # 180 degrees
speed=1


TILE_SIZE = int((SCREEN_WIDTH / 2) / MAP_SIZE )

player_x= int(( SCREEN_WIDTH / 2)  /2 )
player_y= int(( SCREEN_WIDTH / 2)  /2 )

CASTED_RAYS=50
STEP_ANGLE = FOV  / CASTED_RAYS

MAX_DEPTH=int(MAP_SIZE * TILE_SIZE)  #similar with MAX_DEPTH=480
SCALE = (SCREEN_WIDTH/2) / CASTED_RAYS

def cast_rays():
    start_angle=player_angle-HALF_FOV
    for rays in range(CASTED_RAYS):
        for depth in range(MAX_DEPTH):
            target_x=player_x - math.sin(start_angle) * depth
            target_y=player_y + math.cos(start_angle) * depth
            pygame.draw.line(win, (0,255,0), (player_x,player_y), (target_x,target_y),3)

            row=int(target_y/TILE_SIZE)
            column=int(target_x/TILE_SIZE)
            square=row * MAP_SIZE + column
            if MAP[square] == '#':
                pygame.draw.rect(win, (0,255,0), (column* TILE_SIZE, row* TILE_SIZE,TILE_SIZE-2, TILE_SIZE-2))
                
                color = 255 / ( 1+depth*depth*0.001 )
                depth = depth*math.cos(player_angle - start_angle)
                wall_height= 21000 / ( depth + 0.0001) #min=21000/480~43pixels, max=
                
                if wall_height> SCREEN_WIDTH:
                        wall_height = SCREEN_HEIGHT




                #SCALE = (SCREEN_WIDTH/2) / CASTED_RAYS
                pygame.draw.rect(win, (color,color,color), (SCREEN_HEIGHT + rays * SCALE, SCREEN_HEIGHT/2 - wall_height/2, SCALE, wall_height ))

                break
        start_angle += STEP_ANGLE

def draw_map():
    for row in range(MAP_SIZE):
        for column in range(MAP_SIZE):
            square = row * MAP_SIZE + column

            therectangle=(column * TILE_SIZE, row * TILE_SIZE, TILE_SIZE-2, TILE_SIZE-2)
            pygame.draw.rect(win, (200,200,200) if MAP[square] == '#' else (100,100,100), therectangle  )

    pygame.draw.circle(win,(255,0,0), (int(player_x), int(player_y)), 8)

    startXY=(int(player_x),int(player_y))
    stopXY=(int(player_x - math.sin(player_angle)*50), int(player_y + math.cos(player_angle)*50))
    pygame.draw.line(win, (0,255,0), (startXY), (stopXY), 3 )

    stopXY=(int(player_x - math.sin(player_angle-HALF_FOV)*50), int(player_y+math.cos(player_angle-HALF_FOV)*50 ))
    pygame.draw.line(win, (0,255,0), (startXY), (stopXY), 3 )

    stopXY=(int(player_x - math.sin(player_angle+HALF_FOV)*50), int(player_y+math.cos(player_angle+HALF_FOV)*50 ))
    pygame.draw.line(win, (0,255,0), (startXY), (stopXY), 3 )


win = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
clock =  pygame.time.Clock()
forward=True
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit(0)

    #2d
    pygame.draw.rect(win, (0,0,0),(0,0,SCREEN_HEIGHT, SCREEN_HEIGHT))

    #3d
    pygame.draw.rect(win, (100,100,100), (480, SCREEN_HEIGHT/2, SCREEN_HEIGHT, SCREEN_HEIGHT))
    pygame.draw.rect(win, (200,200,200), (480, -SCREEN_HEIGHT/2, SCREEN_HEIGHT, SCREEN_HEIGHT))
    

    draw_map()
    cast_rays()

    column= int(player_x / TILE_SIZE)
    row = int(player_y / TILE_SIZE)
    square = row * MAP_SIZE + column

    if MAP[square]== '#':
        if forward:
            player_x -= -math.sin(player_angle) * speed
            player_y -= math.cos(player_angle) * speed
        else:
            player_x += -math.sin(player_angle) * speed
            player_y += math.cos(player_angle) * speed


    keys= pygame.key.get_pressed()
    if keys[pygame.K_LEFT]: player_angle -= 0.1
    if keys[pygame.K_RIGHT]: player_angle += 0.1
    if keys[pygame.K_UP]:
        forward=True
        player_x += -math.sin(player_angle) * speed
        player_y += +math.cos(player_angle) * speed
    if keys[pygame.K_DOWN]:
        forward=False
        player_x += +math.sin(player_angle) * speed
        player_y += -math.cos(player_angle) * speed
    if keys[pygame.K_p]:
        speed +=1
    if keys[pygame.K_m]:
        speed -= 1
        if speed < 0 : speed =1


    fps=str(int(clock.get_fps()))
    font=pygame.font.SysFont('Monospace Regular', 30)
    textsurface = font.render(fps, False, (255,255,255))
    win.blit(textsurface, (SCREEN_WIDTH/2,0))

    pygame.display.flip()
    clock.tick(30)